main/urls.py
from django.urls import path
from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='home'),
    path('home/', views.home, name='home'),
    path('about_me/', views.about_me, name='about_me'),
    path('education/', views.education, name='education'),
    path('skills/', views.skills, name='skills'),
    path('projects/', views.projects, name='projects'),
    path('achievement/', views.achievement, name='achievement'),
    path('matkul/', views.matkul, name='matkul'),
    path('accordion/', views.accordion, name='accordion'),
    path('mata_kuliah/', views.mata_kuliah, name='mata_kuliah'),
    path('list_matkul/', views.read_person, name='read'),
    path('detail/<int:nomor>/', views.detail, name='detail'),
    path('delete/<int:nomor>/', views.delete, name='delete'),
    path('pencarian/', views.pencarian, name='pencarian'),
    path('datas', views.datas, name='datas'),
]

story4/urls.py
from django.contrib import admin
from django.urls import include, path
from register import views as vreg

urlpatterns = [
    path('admin/', admin.site.urls),
    path('register/',vreg.register, name="register"),
    path('', include('main.urls')),
    path('',include("django.contrib.auth.urls")),
]

main/models.py
from django.db import models

# Create your models here.
class Person(models.Model):
    mata_kuliah = models.CharField(max_length=1000)
    dosen = models.CharField(max_length=1000, null=True)
    jumlah_sks = models.CharField(max_length=1000,null=True)
    deskripsi = models.CharField(max_length=1000,null=True)
    semester_tahun = models.CharField(max_length=1000,null=True)

class anggota(models.Model):
    nama_anggota = models.CharField(max_length=1000,null=True)

class daftar_kegiatan(models.Model):
    nama_kegiatan = models.CharField(max_length=1000,null=True)
    anggota_kelompok = models.ManyToManyField(anggota)

main/forms.py
from django import forms
from .models import Person, daftar_kegiatan, anggota

class Input_form(forms.ModelForm):
    class Meta:
        model = Person
        fields = '__all__'

    error_messages = {
        'required' : 'Please Type'
    }

    input_attrs_matkul = {
        'type' : 'text',
        'placeholder' : 'Nama mata kuliah'
    }

    input_attrs_dosen ={
        'type' : 'text',
        'placeholder' : 'Nama Dosen'
    }

    input_attrs_sks ={
        'type' : 'text',
        'placeholder' : 'Jumlah SKS mata kuliah'
    }

    input_attrs_deskripsi ={
        'type' : 'text',
        'placeholder' : 'Deskripsi mata kuliah'
    }

    input_attrs_semester ={
        'type' : 'text',
        'placeholder' : 'Gasal/Genap - Tahun'
    }

    mata_kuliah = forms.CharField(label='Mata kuliah ', required=True, max_length=1000, widget=forms.TextInput(attrs=input_attrs_matkul))
    dosen = forms.CharField(label='Dosen ', required=True, max_length=1000, widget=forms.TextInput(attrs=input_attrs_dosen))
    jumlah_sks = forms.CharField(label='Jumlah SKS ', required=True, max_length=1000, widget=forms.TextInput(attrs=input_attrs_sks))
    deskripsi = forms.CharField(label='Deskripsi ', required=True, max_length=1000, widget=forms.TextInput(attrs=input_attrs_deskripsi))
    semester_tahun = forms.CharField(label='Semester ', required=True, max_length=1000, widget=forms.TextInput(attrs=input_attrs_semester))

class Input_form_2(forms.ModelForm):
    class Meta:
        model = daftar_kegiatan
        fields = '__all__'

    error_messages = {
        'required' : 'Please Type'
    }

    input_attrs_nama_kegiatan = {
        'type' : 'text',
        'placeholder' : 'Nama kegiatan'
    }

    nama_kegiatan = forms.CharField(label='Nama kegiatan ', required=True, max_length=1000, widget=forms.TextInput(attrs=input_attrs_nama_kegiatan))

class Input_form_3(forms.ModelForm):
    class Meta:
        model = anggota
        fields = '__all__'

    error_messages = {
        'required' : 'Please Type'
    }

    input_attrs_nama_anggota = {
        'type' : 'text',
        'placeholder' : 'Nama'
    }

    nama_anggota = forms.CharField(label='Nama anggota ', required=True, max_length=1000, widget=forms.TextInput(attrs=input_attrs_nama_anggota))

main/views.py
from django.shortcuts import render
from datetime import datetime, date
from .forms import Input_form, Input_form_2, Input_form_3
from django.http import HttpResponseRedirect
from .models import Person, daftar_kegiatan, anggota
from django.http import JsonResponse
import requests #Note: kalau mau pake ini, kita harus "pip install requests" dulu di cmd venv kita
import json


mhs_name = 'Ahmad Dzikrul Fikri' 
curr_year = int(datetime.now().strftime("%Y"))
birth_date = date(1999,7,29) 
npm = 1806196806 
angkatan = 2018
universitas = 'Universitas Indonesia'
hobi = 'Tidur sambil main HP'
deskripsi = 'Saya adalah pribadi yang senang mencoba hal baru. Saya berharap mendapatkan pengalaman yang nantinya akan berguna bagi kehidupan saya'
SD = "SDN Bojongrangkas 04"
SMP = "SMPN 1 Cibungbulang"
SMA = "SMAN 1 Leuwiliang"
sosmed1 = "ahmaddzikrulfikri"
sosmed2 = "Ahmad Dzikrul Fikri"
desc_form = "Silahkan isi data mata kuliah anda"
desc_form_kegiatan = "Silahkan isi data kegiatan anda"
aktivitas = "Mengerjakan tugas PPW"
organisasi = "Staff biro kewirausahaan HMGS, Kabiro kewirausahaan HMGS"
kepanitiaan = "Staff divisi tugas PDGs, Koor lomba 2 GGC UI"
prestasi = "Juara 2 SIC UI 2017, Juara turnamen basket SMK Cahaya 2016"

def home(request):
    response = {'name': mhs_name, 'age': calculate_age(birth_date.year), 'npm': npm, 'angkatan': angkatan, 'universitas':universitas,'hobi':hobi, 'deskripsi': deskripsi, 'sosmed1':sosmed1, 'sosmed2':sosmed2,'SD':SD, 'SMP':SMP,'SMA':SMA}
    return render(request, 'main/home.html',response)

def accordion(request):
    response = {'aktivitas':aktivitas, 'organisasi':organisasi, "kepanitiaan":kepanitiaan, "prestasi":prestasi}
    return render(request, 'main/accordion.html',response)

def about_me(request):
    response = {'deskripsi': deskripsi}
    return render(request, 'main/about_me.html',response)

def matkul(request):
    response = {'deskripsi' : desc_form, 'input_form' : Input_form}
    return render(request, 'main/matkul.html',response)

def kegiatan(request):
    response = {'deskripsi' : desc_form_kegiatan, 'input_form' : Input_form_2}
    return render(request, 'main/kegiatan.html',response)

def education(request):
    return render(request, 'main/education.html')

def skills(request):
    return render(request, 'main/skills.html')

def projects(request):
    return render(request, 'main/projects.html')

def achievement(request):
    return render(request, 'main/achievement.html')

def calculate_age(birth_year):
    return curr_year - birth_year if birth_year <= curr_year else 0

def mata_kuliah(request):
    form = Input_form(request.POST or None)
    if (form.is_valid and request.method == 'POST') :
        form.save()
        return HttpResponseRedirect('/list_matkul')
    else:
        return HttpResponseRedirect('/')

def read_person(request):
    persons = Person.objects.all()
    response = {
        'persons':persons
    }
    return render(request, 'main/list_matkul.html', response)

def delete(request,nomor):
    Person.objects.filter(id=nomor).delete()
    return HttpResponseRedirect('/list_matkul')

def detail(request,nomor):
    details = Person.objects.get(id=nomor)
    response = {
        'details':details
    }
    return render(request, 'main/detail.html', response)

def pencarian(request):
    try :
        request.session['has_search'] = request.session['has_search'] +1
    except :
        request.session['has_search'] = 1
    response = {
        "jumlah_pencarian":request.session['has_search']
    }
    return render(request, 'main/pencarian.html',response)

def datas(request):
    url = 'https://www.googleapis.com/books/v1/volumes?q=' + request.GET['q']
    ret = requests.get(url)
    data = json.loads(ret.content)
    return JsonResponse(data, safe = False)

main/templates/main/about_me.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>about_me</title>
{% endblock meta %}

{% block content %}
    <body>
        <article id="article2" class="bg_yellow"><img src="{% static 'formal.jpg' %}" class="img-fluid" alt="Responsive image"></article>
        <article id="article1" class="bg_yellow">{{ deskripsi }}</article>
    </body>
{% endblock content %}

main/templates/main/accordion.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>accordion page</title>
{% endblock meta %}

{% block content %}

<link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
<script src="https://code.jquery.com/jquery-1.12.4.js"></script>
<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>

<script type="text/javascript" src="{% static 'myJs.js' %}">
</script>

<div id="accordion">
    Aktivitas terkini
    <div>
    <h3>
        Aktivitas terkini
    </h3>
    </div>
        <div>
            <p>
            {{aktivitas}}
            </p>
        </div>


    <div>
    <button onclick="move_down()">V</button>
    <button onclick="move_up()">^</button>
    <h3>Pengalaman Kepanitiaan</h3>
    </div>
        <div>
            <p>
            {{kepanitiaan}}
            </p>
        </div>

    <div>
    <button onclick="move_down()">V</button>
    <button onclick="move_up()">^</button>
    <h3>Pengalaman Organisasi</h3>
    </div>    
        <div>
        <p>
            {{organisasi}}
        </p>
        </div>

    <div>
    <button onclick="move_down()">V</button>
    <button onclick="move_up()">^</button>
    <h3>Prestasi</h3>
    </div>
        <div>
        <p>
            {{prestasi}}
        </p>
        </div>
</div>


{% endblock content %}

main/templates/main/achievement.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>about_me</title>
{% endblock meta %}

{% block content %}
    <body>
        <article id="article2" class="bg_yellow"><img src="{% static 'penghargaan.jpg' %}" class="img-fluid" alt="Responsive image"></article>
        <article id="article1" class="bg_yellow">Berikut merupakan daftar project yang telah saya selesaikan :<br/>
            - Juara 2 SIC <br/>
            - Juara 1 Basket<br/>
            - Juara 1 lomba lari<br/>
        </article>
    </body>
{% endblock content %}

main/templates/main/detail.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>detail_matkul</title>
{% endblock meta %}

{% block content %}
    <body>
        <table class="table">
            <thead>
                <tr>
                <th scope="col">Mata kuliah</th>
                <th scope="col">Dosen</th>
                <th scope="col">SKS</th>
                <th scope="col">Deskripsi</th>
                <th scope="col">Semester</th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>{{ details.mata_kuliah }}</td>
                    <td>{{ details.dosen }}</td>
                    <td>{{ details.jumlah_sks}}</td>
                    <td>{{ details.deskripsi}}</td>
                    <td>{{ details.semester_tahun}}</td>
                </tr>
            </tbody>
        </table>
        <a class="btn btn-primary" href="/list_matkul">Kembali</a>
    </body>
{% endblock content %}

main/templates/main/education.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>about_me</title>
{% endblock meta %}

{% block content %}
    <body>
        <article id="article2"  class="bg_yellow"><img src="{% static 'Riwayat pendidikan.jpg' %}" class="img-fluid" alt="Responsive image"></article>
        <article id="article1" class="bg_yellow">Saat ini saya adalah Mahasiswa Geofisika, Fakultas Matematika dan Ilmu Pengetahuan Alam, Universitas Indonesia. Sebelumnya saya telah menempuh pendidikan dasar di beberapa sekolah, yaitu:<br/>
            - SDN Bojongrangkas 04<br/>
            - SMPN 1 Cibungbulang<br/>
            - SMAN 1 Leuwiliang
        </article>
    </body>
{% endblock content %}

main/templates/main/home.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Home</title>
{% endblock meta %}

{% block content %}
  <h1>Hello, world!, My name is {{ name }}</h1>
  <article>Berikut merupakan profil saya</article>
  <table>
    <tr>
      <td>Nama</td>
      <td>: {{ name }}</td>
    </tr>
    <tr>
      <td>NPM</td>
      <td>: {{ npm }}</td>
    </tr>
    <tr>
      <td>Angkatan</td>
      <td>: {{ angkatan }}</td>
    </tr>
    <tr>
      <td>Universitas</td>
      <td>: {{ universitas }}</td>
    </tr>
    <tr>
       <td>Hobi</td>
      <td>: {{ hobi }}</td>
    </tr>
    <tr>
      <td>Deskripsi</td>
      <td>: {{ deskripsi }}</td>
    </tr>
    <tr>
      <td>Sosial media</td>
      <td>
        <article>:&nbsp;<img src="{% static 'img/icon_instagram.jpg' %}" alt="instagram" height="15" width="15"> {{ sosmed1 }}</article>
        <article>&ensp;<img src="{% static 'img/icon_facebook.png' %}" alt="facebook" height="15" width="15"> {{ sosmed2 }}</article>
       </td>
    </tr>
    <tr>
      <td>Foto</td>
      <td>: 
        <img src="{% static 'formal.jpg' %}" class="img-fluid" alt="Responsive image">
      </td>
    </tr>
  </table>
  <h2>Riwayat Pendidikan</h2>
  <table border=1>
    <tr>
      <td>Sekolah Dasar</td>
      <td> {{ SD }}</td>
    </tr>
    <tr>
      <td>Sekolah Menengah Pertama</td>
      <td> {{ SMP }}</td>
    </tr>
    <tr>
      <td>Sekolah Menengah Atas</td>
      <td> {{ SMA }}</td>
    </tr>
  </table>
{% endblock content %}

main/templates/main/list_matkul.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>form_matkul</title>
{% endblock meta %}

{% block content %}
    <body>
        <table class="table">
            <thead>
              <tr>
                <th scope="col">Nomor</th>
                <th scope="col">Mata kuliah</th>
                <th scope="col">Dosen</th>
                <th scope="col">SKS</th>
                <th scope="col">Detail</th>
                <th scope="col">Hapus</th>
              </tr>
            </thead>
            <tbody>
            {% if persons %}
                {% for person in persons %}
                    <tr>
                        <th scope="row">{{forloop.counter}}</th>
                        <td>{{ person.mata_kuliah }}</td>
                        <td>{{ person.dosen }}</td>
                        <td>{{ person.jumlah_sks}}</td>
                        <td><a class="btn btn-primary" href="{% url 'main:detail' person.id %}" title="">Detail</a></td>
                        <td><a class="btn btn-danger" href="{% url 'main:delete' person.id %}" title="">Delete</a></td>
                    </tr>
                {% endfor %}
            {% endif %}
            </tbody>
          </table>
          <a class="btn btn-primary" href="/matkul">Input</a>
    </body>
{% endblock content %}

main/templates/main/matkul.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>form_matkul</title>
{% endblock meta %}

{% block content %}
    <body>
        <article id="article1" class="bg_yellow">{{ deskripsi }}</article>
        <form action="mata_kuliah" method="POST">
            {% csrf_token %}
            <table>
                {{ input_form.as_table }}
            </table>
            <input type="submit" class="btn btn-primary" value="Submit">
            &emsp;<a class="btn btn-primary" href="/list_matkul">Lihat jadwal</a>
        </form>
    </body>
{% endblock content %}

main/templates/main/pencarian.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Pencarian buku</title>
{% endblock meta %}

{% block content %}
<head>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
</head>

<input id="keyword" placeholder="Masukkan kata kunci">
{% if user.is_authenticated %}
<article>Jumlah anda mengunjungi halaman ini adalah {{ jumlah_pencarian }} kali</article>
{% endif %}
<br/><br/>
<table class="table table-bordered table-dark">
    <thead>
        <tr>
          <th scope="col">Nama Buku</th>
          <th scope="col">Sampul Buku</th>
        </tr>
      </thead>
    <tbody id="daftar_isi">
    </tbody>
  </table>
<script type="text/javascript">
    $("#keyword").keyup(function(){
        var ketikan = $("#keyword").val();
        $.ajax({
            url:'/datas?q='+ketikan,
            success: function(data) {
                var data_items = data.items;
                $("#daftar_isi").empty();
                for (i = 0; i < data_items.length; i++) {
                    var judul = data_items[i].volumeInfo.title;
                    var gambar = data_items[i].volumeInfo.imageLinks.smallThumbnail;
                    $("#daftar_isi").append("<tr><td>"+ judul +"</td><td><img src="+ gambar +"></td></tr>");
                }
            }
        });
    })
</script>
{% endblock content %}

main/templates/main/projects.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>about_me</title>
{% endblock meta %}

{% block content %}
    <body>
        <article id="article2" class="bg_yellow"><img src="{% static 'project.jpg' %}" class="img-fluid" alt="Responsive image"></article>
        <article id="article1" class="bg_yellow">Berikut merupakan daftar project yang telah saya selesaikan :<br/>
            - Ewas<br/>
            - sensor tanah longsor<br/>
            - saham tambang otomatis
            </article>
    </body>
{% endblock content %}

main/templates/main/skills.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>about_me</title>
{% endblock meta %}

{% block content %}
    <body>
        <article id="article2" class="bg_yellow"><img src="{% static 'skills.jpg' %}" class="img-fluid" alt="Responsive image"></article>
        <article id="article1" class="bg_yellow">Berikut merupakan daftar keahlian yang saya miliki :<br/>
            - Project management<br/>
            - Strong communication and interpersonal skills<br/>
            - Fast learner<br/>
            - Team player<br/>
            - Hard working<br/>
            - Motivated and dedicated</article>
    </body>
{% endblock content %}